#!/usr/bin/python3

import sys
import string
import select
from socket import *

class Client():
    def __init__(self, address):
    	self.address = address

def printHelp():
    print('Usage: {} <local port>'.format(sys.argv[0]))

def shutdown():
    sd.close()
    exit(0)

try:
    lport = int(sys.argv[1])
except:
    printHelp()
    exit(1)

sd = socket(AF_INET, SOCK_DGRAM)
sd.bind(('', lport))

rfds = [sd, sys.stdin]

clients = {}

while True:
    address = None
    msg = None

    try:
        rfd, _, _ = select.select(rfds, [], [])
    except:
        shutdown()

    if sys.stdin in rfd:
        # We have typed something to send
        msg = sys.stdin.readline()
    elif sd in rfd:
        # We have received something
        data, address = sd.recvfrom(4096)
        try:
            msg = data.decode()
        except:
            continue
        msg = ''.join(filter(lambda x: x in string.printable, msg))
        msg = '{}:{} >> {}'.format(address[0], address[1], msg)

        clients[address] = Client(address)

        print(msg, end='')
    else:
        # Should not happen
        print('should never happened')

    data = bytearray(msg, 'ascii')

    for addr, c in clients.items():
        if address == c.address:
            continue
        sd.sendto(data, c.address)


